package presentacion;

import javax.swing.*; 
import java.awt.*; 
import java.util.Vector; 

// got this workaround from the following bug: 
//      http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=4618607 

/**
 * Got this workaround from the following bug:
 * http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=4618607
 * 
 * @author Santhosh Kumar's Weblog
 */
@SuppressWarnings({"unchecked","rawtypes"})
public class WideComboBox extends JComboBox{ 

	private static final long serialVersionUID = 1L;
	private boolean layingOut = false;
	
	/**
	 * Creador.
	 */
	public WideComboBox() { 
    }

	/**
	 * Creador.
	 * 
	 * @param items
	 */
    public WideComboBox(final Object items[]){ 
        super(items); 
    }

    /**
     * Creador.
     * 
     * @param items
     */
	public WideComboBox(Vector items) { 
        super(items); 
    }
    
	/**
	 * Creador.
	 * 
	 * @param aModel
	 */
	public WideComboBox(ComboBoxModel aModel) { 
        super(aModel); 
    }

    public void doLayout(){ 
        try{ 
            layingOut = true; 
                super.doLayout(); 
        }finally{ 
            layingOut = false; 
        } 
    }
    
    public Dimension getSize(){ 
        Dimension dim = super.getSize(); 
        if(!layingOut) 
            dim.width = Math.max(dim.width, getPreferredSize().width); 
        return dim; 
    }
}
